    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ----------------------
    028 * BasicStrokeReadHandler
    029 * ----------------------
    030 * (C) Copyright 2003, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: BasicStrokeReadHandler.java,v 1.2 2005/10/18 13:33:32 mungady Exp $
    036 *
    037 * Changes (from 25-Nov-2003)
    038 * --------------------------
    039 * 25-Nov-2003 : Added standard header and Javadocs (DG);
    040 *
    041 */
    042
    043package org.jfree.xml.parser.coretypes;
    044
    045import java.awt.BasicStroke;
    046import java.util.StringTokenizer;
    047
    048import org.jfree.xml.parser.AbstractXmlReadHandler;
    049import org.xml.sax.Attributes;
    050import org.xml.sax.SAXException;
    051
    052/**
    053 * A SAX handler for reading a {@link BasicStroke} object from XML.
    054 * <p>
    055 * To do: this should have a multiplexer in front like the PaintReadHandler
    056 */
    057public class BasicStrokeReadHandler extends AbstractXmlReadHandler  {
    058
    059    /** The stroke under construction. */
    060    private BasicStroke stroke;
    061
    062    /**
    063     * Creates a new handler.
    064     */
    065    public BasicStrokeReadHandler() {
    066        super();
    067    }
    068
    069    /**
    070     * Called at the start of parsing a {@link BasicStroke} element, this method reads the
    071     * attributes and constructs the stroke.
    072     *
    073     * @param attrs  the attributes.
    074     *
    075     * @throws SAXException to indicate a parsing error.
    076     */
    077    protected void startParsing(final Attributes attrs) throws SAXException {
    078        final int endCap = Integer.parseInt(attrs.getValue("endCap"));
    079        final int lineJoin = Integer.parseInt(attrs.getValue("lineJoin"));
    080        final float lineWidth = Float.parseFloat(attrs.getValue("lineWidth"));
    081        final float miterLimit = Float.parseFloat(attrs.getValue("miterLimit"));
    082        final String dashArrayAttrib = attrs.getValue("dashArray");
    083        if (dashArrayAttrib != null) {
    084            final float[] dashArray = parseDashArray(dashArrayAttrib);
    085            final float dashPhase = Float.parseFloat(attrs.getValue("dashPhase"));
    086            this.stroke = new BasicStroke(
    087                lineWidth, endCap, lineJoin, miterLimit, dashArray, dashPhase
    088            );
    089        }
    090        else {
    091            this.stroke = new BasicStroke(lineWidth, endCap, lineJoin, miterLimit);
    092        }
    093    }
    094
    095    /**
    096     * Parses the dash array.
    097     *
    098     * @param string  the dash array string representation.
    099     *
    100     * @return a dash array.
    101     */
    102    private float[] parseDashArray(final String string) {
    103        final StringTokenizer tokenizer = new StringTokenizer(string, ",");
    104        final float[] retVal = new float[tokenizer.countTokens()];
    105        for (int i = 0; i < retVal.length; i++) {
    106            retVal[i] = Float.parseFloat(tokenizer.nextToken());
    107        }
    108        return retVal;
    109    }
    110
    111    /**
    112     * Returns the stroke under construction.
    113     *
    114     * @return the stroke.
    115     */
    116    public Object getObject() {
    117        return this.stroke;
    118    }
    119
    120}